package apps.yesim.domain.entity;

import java.util.List;
import java.util.Set;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.OneToMany;
import javax.persistence.Transient;

import lombok.Getter;
import lombok.Setter;

import org.hibernate.validator.constraints.Email;
import org.hibernate.validator.constraints.NotEmpty;

/**
 * 
 * @author Gabriel Cardelli
 *
 */
@Entity
@NamedQueries({
	
	@NamedQuery(name="getPersonByEmailAndPassword",query="From Person where email = ?1 and password = ?2")
	
})
public class Person {

	@Id
	@GeneratedValue
	@Getter
	private Long id;

	@NotEmpty
	@Getter @Setter
	private String name;
	

	@NotEmpty
	@Getter @Setter
	private String username;

	@NotEmpty
	@Getter @Setter
	private String password;
	
	
	@Email @NotEmpty
	@Getter @Setter
	private String email;
	
	
	@Getter @Setter
	private String photoUrl;

	@ManyToMany
	@JoinTable(name="friends",
			joinColumns={@JoinColumn(name="person_id")},
			inverseJoinColumns={@JoinColumn(name="friend_id")})
	@Getter @Setter
	private List<Person> friends;

	@OneToMany
	@JoinColumn(name="person_id")
	@Getter @Setter
	private List<Question> questions;
	
	@ManyToOne
	@Getter @Setter
	private Paper paper;
	
	@Transient
	public Set<String> getRolesName() {
		// TODO Auto-generated method stub
		return null;
	}

	
}
