package apps.yesim.infra.repository.impl;

import javax.persistence.EntityManager;
import javax.persistence.Query;

import lombok.extern.java.Log;
import apps.yesim.domain.entity.Person;
import apps.yesim.domain.repository.PersonRepository;
import apps.yesim.util.jpa.EntityManagerBuilder;
import apps.yesim.util.param.LoginParams;

/**
 * 
 * @author cardelli
 *
 */
@Log
public class PersonRepositoryImpl implements PersonRepository {

	private EntityManager entityManager;
	
	public PersonRepositoryImpl() {
		this.entityManager = EntityManagerBuilder.getEntityManager();
	}
	
	@Override
	public Person getByEmailAndPassword(LoginParams params) {
		
		log.info(params.toString());
		
		Query query = entityManager.createNamedQuery("getPersonByEmailAndPassword");
		
		
		
		query.setParameter(1, params.getEmail());
		query.setParameter(2, params.getPassword());
		
	
		
		return (Person) query.getSingleResult();
	}

}
