package apps.yesim.managedBean;

import javax.faces.application.FacesMessage;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.UsernamePasswordToken;
import org.hibernate.annotations.AccessType;

import lombok.Getter;
import lombok.Setter;
import lombok.extern.java.Log;
import apps.yesim.domain.entity.Person;
import apps.yesim.domain.repository.PersonRepository;
import apps.yesim.util.param.LoginParams;


/**
 * 
 * @author Gabriel Cardelli
 *
 */
@Named
@RequestScoped
@Log
public class IndexBean {
	
	@Inject @Setter
	private PersonRepository personRepository;
	
	@Inject @Getter @Setter
	private LoginParams loginParams;
	
	

	public String login(){	
		
		
		
		FacesMessage message = null;
		
		try{
			
			log.info(loginParams.toString());
			
			
			Person person = personRepository.getByEmailAndPassword(loginParams);	
			
			UsernamePasswordToken auth = new UsernamePasswordToken(loginParams.getEmail(), loginParams.getPassword());
			auth.setRememberMe(true);
			
			SecurityUtils.getSubject().login(auth);
			
			message = new FacesMessage("Logado com sucesso " + SecurityUtils.getSubject().getPrincipal());
			
		}catch(Exception e){
			
			message = new FacesMessage("Dados Invalidos");
			log.info(e.getMessage());
			e.printStackTrace();
			
		}finally{
			
			FacesContext.getCurrentInstance().addMessage("loginMessage", message);		
			
		}
		
		return "index";
		
	}	
	
	
	public String logout(){
		
		SecurityUtils.getSubject().logout();
		
		return "index";
	}

}
